<?php

namespace App\Filament\Resources;

use App\Filament\Exports\GrMasterExporter;
use App\Filament\Imports\GrMasterImporter;
use App\Filament\Resources\GrMasterResource\Pages;
use App\Filament\Resources\GrMasterResource\RelationManagers;
use App\Models\GrMaster;
use App\Models\Item;
use App\Models\Plant;
use Filament\Facades\Filament;
use Filament\Forms;
use Filament\Forms\Form;
use Filament\Resources\Resource;
use Filament\Tables;
use Filament\Tables\Table;
use Illuminate\Database\Eloquent\Builder;
use Illuminate\Database\Eloquent\SoftDeletingScope;
use Filament\Notifications\Notification;
use Filament\Forms\Components\Actions\Action;
use Storage;
use Smalot\PdfParser\Parser;
use Livewire\Features\SupportFileUploads\TemporaryUploadedFile;
use Filament\Tables\Actions\ImportAction;
use Filament\Tables\Actions\ExportAction;
use Illuminate\Validation\Rule;
use thiagoalessio\TesseractOCR\TesseractOCR;
use setasign\Fpdi\Fpdi;
use setasign\Fpdi\PdfReader;
use SimpleSoftwareIO\QrCode\Facades\QrCode;




class GrMasterResource extends Resource
{
    protected static ?string $model = GrMaster::class;

    protected static ?string $navigationIcon = 'heroicon-o-rectangle-stack';

    protected static ?string $navigationGroup = 'Process Order';

    public static function form(Form $form): Form
    {
        return $form
            ->schema([
                Forms\Components\Select::make('plant_id')
                    ->label('Plant')
                    ->reactive()
                    ->relationship('plant', 'name')
                    ->options(function (callable $get) {
                        $userHas = Filament::auth()->user()->plant_id;
                        return ($userHas && strlen($userHas) > 0) ? Plant::where('id', $userHas)->pluck('name', 'id')->toArray() : Plant::pluck('name', 'id')->toArray();
                    })
                    ->required(),
                Forms\Components\Select::make('item_id')
                    ->label('Item Code')
                    //->relationship('item', 'id')
                    ->reactive()
                    ->searchable()
                    ->options(function (callable $get) {
                        $plantId = $get('plant_id');
                        if (empty($plantId)) {
                            return [];
                        }
                        return Item::where('plant_id', $plantId)->pluck('code', 'id');
                    })
                    ->required(),
                Forms\Components\TextInput::make('gr_number')
                    ->label('GR Number')
                    ->minLength(7)
                    ->required(),
                Forms\Components\TextInput::make('serial_number')
                    ->label('Serial Number')
                    ->rule(function (callable $get) {
                                return Rule::unique('gr_masters', 'serial_number')
                                    ->where('plant_id', $get('plant_id'))
                                    ->ignore($get('id')); // Ignore current record during updates
                    }),

                Forms\Components\FileUpload::make('attachment')
                    ->label('PDF Upload')
                    ->acceptedFileTypes(['application/pdf'])
                    ->storeFiles(false)
                    ->disk('local')
                    ->directory('uploads/temp')
                    ->preserveFilenames()
                    ->reactive(),
                Forms\Components\Actions::make([
                    Action::make('uploadNow')
                        ->label('Upload PDF Now')
                        ->action(function ($get, callable $set) {
                            $uploadedFiles = $get('attachment');

                            if (is_array($uploadedFiles) && count($uploadedFiles) > 0)
                            {
                                $uploaded = reset($uploadedFiles);

                                if ($uploaded instanceof TemporaryUploadedFile) {
                                    $grNumber = $get('gr_number');
                                    $safeName = preg_replace('/[^A-Za-z0-9_\-]/', '_', $grNumber);
                                    // $originalName = $uploaded->getClientOriginalName();
                                    // $path = 'uploads/GRNumber/' . $originalName;
                                    $finalFileName = $safeName . '.pdf';
                                    $finalPath = 'uploads/GRNumber/' . $finalFileName;

                                    if (Storage::disk('local')->exists($finalPath)) {
                                        Notification::make()
                                            ->title('Duplicate File')
                                            ->body("The file '{$finalFileName}' already exists in uploads/GRNumber.")
                                            ->warning()
                                            ->send();
                                        return; // Stop here
                                    }

                                    $storedPath = $uploaded->storeAs(
                                        'uploads/GRNumber',
                                        $finalFileName,
                                        'local'
                                    );


                                   // $fullPath = storage_path('app/' . $storedPath);
                                    $fullPath = storage_path('app/private/' . $storedPath);
                                    $parser = new Parser();
                                    //$pdf = $parser->parseContent(file_get_contents($uploaded->getRealPath()));
                                    $pdf = $parser->parseFile($fullPath);
                                    $text = $pdf->getText();

                                    //dd($text);

                                    if (preg_match('/Item code\s*:\s*(\S+)/i', $text, $matches)) {
                                        $item1 = $matches[1];
                                    }
                                    // else if (preg_match('/E CODE\s*:\s*(\S+)/i', $text, $matches)) {

                                    //     $item2 = $matches[1];
                                    //     dd($item2);
                                    // }
                                    else
                                    {
                                        Notification::make()
                                            ->title('Item Code Not Found')
                                            ->body('Could not find Item code in uploaded PDF.')
                                            ->warning()
                                            ->send();

                                        if (Storage::disk('local')->exists($storedPath)) {
                                            Storage::disk('local')->delete($storedPath);
                                        }
                                        return;
                                    }

                                    $processOrder = $get('gr_number');

                                    $itemId = $get('item_id');

                                    $plant = $get('plant_id');

                                    $item = Item::find($itemId);

                                    $plant = Plant::find($plant);

                                    if ($item)
                                    {
                                        $itemCode = $item->code;
                                    }
                                    else
                                    {
                                        $itemCode = null;
                                        Notification::make()
                                            ->title('Item Not Found')
                                            ->body("Item not found in uploaded pdf.")
                                            ->warning()
                                            ->send();
                                        if (Storage::disk('local')->exists($storedPath)) {
                                            Storage::disk('local')->delete($storedPath);
                                        }
                                        return;
                                    }

                                    $storedPath = $uploaded->storeAs(
                                        'uploads/GRNumber',
                                        $finalFileName,
                                        'local'
                                    );

                                    if($itemCode == $item1)
                                    {
                                        Notification::make()
                                        ->title('Success')
                                        ->body("Gr Number '$processOrder' PDF uploaded successfully.")
                                        ->success()
                                        ->send();
                                        return;
                                    }
                                    else
                                    {
                                        Notification::make()
                                        ->title('Item Code not matched')
                                        ->body("Item Code: {$item->code} not matched with the uploaded pdf code $item1.")
                                        ->danger()
                                        ->send();

                                        if (Storage::disk('local')->exists($storedPath)) {
                                            Storage::disk('local')->delete($storedPath);
                                        }
                                        return;
                                    }
                                }
                            }
                            else
                            {
                                Notification::make()
                                    ->title('No file selected to upload')
                                    ->warning()
                                    ->send();
                                    return;
                            }
                        }),
                        // Action::make('uploadNow1')
                        // ->label('Upload OCR')
                        // ->action(function ($get, callable $set) {
                        //     $uploadedFiles = $get('photo');

                        //     if (is_array($uploadedFiles) && count($uploadedFiles) > 0)
                        //     {
                        //         $uploaded = reset($uploadedFiles);

                        //         if ($uploaded instanceof TemporaryUploadedFile) {
                        //             $grNumber = $get('gr_number');
                        //             $safeName = preg_replace('/[^A-Za-z0-9_\-]/', '_', $grNumber);
                        //             // $originalName = $uploaded->getClientOriginalName();
                        //             // $path = 'uploads/GRNumber/' . $originalName;
                        //             $finalFileName = $safeName . '.jpg';
                        //             $finalPath = 'uploads/OCR/' . $finalFileName;

                        //             // if (Storage::disk('local')->exists($finalPath)) {
                        //             //     Notification::make()
                        //             //         ->title('Duplicate File')
                        //             //         ->body("The file '{$finalFileName}' already exists in uploads/GRNumber.")
                        //             //         ->warning()
                        //             //         ->send();
                        //             //     return; // Stop here
                        //             // }

                        //             $storedPath = $uploaded->storeAs(
                        //                 'uploads/OCR',
                        //                 $finalFileName,
                        //                 'local'
                        //             );

                        //             // $storedPath = $uploaded->storeAs('uploads/OCR', $finalFileName, 'local');
                        //             // $fullPath = storage_path('app/' . $storedPath);
                        //             $storedPath = $uploaded->storeAs('uploads/OCR', $finalFileName, 'local');

                        //             $fullPath = storage_path('app/private/' . $storedPath);

                        //             $text = (new TesseractOCR($fullPath))->lang('eng')->run();

                        //             $rawText = $text;

                        //             preg_match_all('/\d+/', $rawText, $matches);

                        //             $serialNumbers = $matches[0];

                        //             $serialNumbers = array_slice($serialNumbers, 0, 4);

                        //             //dd($serialNumbers);

                        //             $processOrder = $get('gr_number');

                        //             $itemId = $get('item_id');

                        //             $plant = $get('plant_id');

                        //             $item = Item::find($itemId);

                        //             $plant = Plant::find($plant);

                        //             $templatePath = storage_path('app/private/uploads/StickerTemplateOcr/multi.pdf');

                        //             $outputPath = storage_path('app/private/uploads/StickerTemplateOcr/multi_filled.pdf');

                        //             $storedPath = $uploaded->storeAs(
                        //                 'uploads/GRNumber',
                        //                 $finalFileName,
                        //                 'local'
                        //             );

                        //             $pdf = new Fpdi('P', 'mm', [90, 90]);

                        //             $templateId = $pdf->setSourceFile($templatePath);
                        //             $templatePage = $pdf->importPage(1);

                        //             $pdf->AddPage();
                        //             $pdf->useTemplate($templatePage, 0, 0, 90, 90);

                        //             $pdf->SetFont('Helvetica', '', 10);
                        //             $pdf->SetTextColor(0, 0, 0);

                        //             $slots = [
                        //                 ['x' => 5.7,  'y' => 41.9, 'w' => 46.5, 'h' => 3.5],  // 1st serial
                        //                 ['x' => 50, 'y' => 41.5, 'w' => 46.6, 'h' => 3.9],  // 2nd serial
                        //                 ['x' => 5.7,  'y' => 60, 'w' => 46.5, 'h' => 3.5],  // 3rd serial
                        //                 ['x' => 50, 'y' => 60, 'w' => 46.6, 'h' => 3.5],  // 4rd serial
                        //             ];

                        //             $qrSlots = [
                        //                 ['x' => 17.3,  'y' => 29.2, 'size' => 11.4],
                        //                 ['x' => 61.5,   'y' => 29, 'size' => 11.5],
                        //                 ['x' => 17.7,  'y' => 46.7, 'size' => 11.4],
                        //                 ['x' => 61.7,   'y' => 46.7, 'size' => 11.4],
                        //             ];

                        //             // foreach ($serialNumbers as $i => $serial) {
                        //             //     if (isset($slots[$i])) {
                        //             //         $pdf->SetFillColor(255, 255, 255); // erase old serial
                        //             //         $pdf->Rect($slots[$i]['x'], $slots[$i]['y'], $slots[$i]['w'], $slots[$i]['h'], 'F');
                        //             //         $pdf->SetXY($slots[$i]['x'], $slots[$i]['y']);
                        //             //         // $pdf->Write(0, $serial);
                        //             //         $pdf->Cell($slots[$i]['w'], $slots[$i]['h'], $serial, 0, 0, 'L');
                        //             //     }
                        //             // }

                        //             // $pdf->Output('F', $outputPath);
                        //             // return response()->download($outputPath);

                        //             //

                        //             // foreach ($serialNumbers as $i => $serial) {
                        //             //     if (!isset($slots[$i]) || !isset($qrSlots[$i])) continue;

                        //             //     //Generate QR code PNG temporarily
                        //             //     $qrPath = storage_path("app/private/uploads/QR/qr_$serial.png");
                        //             //     QrCode::format('png')->size(100)->generate($serial, $qrPath);

                        //             //     //Place QR code above serial
                        //             //     $pdf->Image($qrPath, $qrSlots[$i]['x'], $qrSlots[$i]['y'], $qrSlots[$i]['size'], $qrSlots[$i]['size']);

                        //             //     //Erase old serial
                        //             //     $pdf->SetFillColor(255, 255, 255);
                        //             //     $pdf->Rect($slots[$i]['x'], $slots[$i]['y'], $slots[$i]['w'], $slots[$i]['h'], 'F');

                        //             //     //Write new serial number
                        //             //     $pdf->SetXY($slots[$i]['x'], $slots[$i]['y']);
                        //             //     $pdf->Cell($slots[$i]['w'], $slots[$i]['h'], $serial, 0, 0, 'L');
                        //             // }

                        //            foreach ($serialNumbers as $i => $serial) {
                        //                 if (!isset($slots[$i]) || !isset($qrSlots[$i])) continue;

                        //                 // Erase old QR completely (slightly larger)
                        //                 $pdf->SetFillColor(255, 255, 255);
                        //                 $pdf->Rect($qrSlots[$i]['x']-1, $qrSlots[$i]['y']-1, $qrSlots[$i]['size']+2, $qrSlots[$i]['size']+2, 'F');

                        //                 // Generate new QR code
                        //                 $qrPath = storage_path("app/private/uploads/QR/qr_$serial.png");
                        //                 $qrDir = storage_path('app/private/uploads/QR');
                        //                 if (!file_exists($qrDir)) mkdir($qrDir, 0777, true);
                        //                 QrCode::format('png')->size(100)->generate($serial, $qrPath);

                        //                 // Place QR code
                        //                 $pdf->Image($qrPath, $qrSlots[$i]['x'], $qrSlots[$i]['y'], $qrSlots[$i]['size'], $qrSlots[$i]['size']);

                        //                 // Erase old serial
                        //                 $pdf->SetFillColor(255, 255, 255);
                        //                 $pdf->Rect($slots[$i]['x'], $slots[$i]['y'], $slots[$i]['w'], $slots[$i]['h'], 'F');

                        //                 // Write new serial
                        //                 $pdf->SetXY($slots[$i]['x'], $slots[$i]['y']);
                        //                 $pdf->Cell($slots[$i]['w'], $slots[$i]['h'], $serial, 0, 0, 'L');
                        //             }

                        //             // Save the final PDF
                        //             $pdf->Output('F', $outputPath);

                        //             // Download
                        //             return response()->download($outputPath);
                        //         }
                        //     }
                        //     else
                        //     {
                        //         Notification::make()
                        //             ->title('No file selected to upload')
                        //             ->warning()
                        //             ->send();
                        //             return;
                        //     }
                        // }),

                    Action::make('downloadAttachment')
                        ->label('Download PDF')
                        ->action(function ($get) {
                            $equipmentNumber = $get('gr_number');

                            if (!$equipmentNumber) {
                                Notification::make()
                                    ->title('No GR Number entered')
                                    ->danger()
                                    ->send();
                                return;
                            }

                            $files = Storage::disk('local')->files('uploads/GRNumber');

                            $fileToDownload = null;
                            foreach ($files as $file) {
                                if (str_contains($file, $equipmentNumber)) {
                                    $fileToDownload = $file;
                                    break;
                                }
                            }

                            if (!$fileToDownload) {
                                Notification::make()
                                    ->title('PDF not found for this process order')
                                    ->danger()
                                    ->send();
                                return;
                            }

                            return response()->download(Storage::disk('local')->path($fileToDownload));
                        }),
                    ]),
                Forms\Components\Hidden::make('created_by')
                    ->label('Created By')
                    ->default(Filament::auth()->user()?->name),
                Forms\Components\Hidden::make('updated_by')
                    ->default(Filament::auth()->user()?->name),
            ]);
    }

    public static function table(Table $table): Table
    {
        return $table
            ->columns([
                Tables\Columns\TextColumn::make('No.')
                    ->label('No.')
                    ->getStateUsing(function ($record, $livewire, $column, $rowLoop) {
                        $paginator = $livewire->getTableRecords();
                        $perPage = method_exists($paginator, 'perPage') ? $paginator->perPage() : 10;
                        $currentPage = method_exists($paginator, 'currentPage') ? $paginator->currentPage() : 1;
                        return ($currentPage - 1) * $perPage + $rowLoop->iteration;
                    }),
                Tables\Columns\TextColumn::make('plant.name')
                    ->label('Plant')
                    ->alignCenter()
                    ->sortable(),
                Tables\Columns\TextColumn::make('item.code')
                    ->label('Item Code')
                    ->searchable()
                    ->alignCenter()
                    ->sortable(),
                Tables\Columns\TextColumn::make('gr_number')
                    ->label('GR Number')
                    ->alignCenter()
                    ->searchable()
                    ->sortable(),
                Tables\Columns\TextColumn::make('serial_number')
                    ->label('Serial Number')
                    ->alignCenter()
                    ->sortable(),
                Tables\Columns\TextColumn::make('created_by')
                    ->label('Created By')
                    ->alignCenter()
                    ->sortable(),
                Tables\Columns\TextColumn::make('status')
                    ->label('Status')
                    ->alignCenter()
                    ->sortable(),
                Tables\Columns\TextColumn::make('created_at')
                    ->label('Created At')
                    ->alignCenter()
                    ->dateTime()
                    ->sortable()
                    ->toggleable(isToggledHiddenByDefault: true),
                Tables\Columns\TextColumn::make('updated_at')
                    ->label('Updated At')
                    ->alignCenter()
                    ->dateTime()
                    ->sortable()
                    ->toggleable(isToggledHiddenByDefault: true),
                Tables\Columns\TextColumn::make('deleted_at')
                    ->label('Deleted At')
                    ->alignCenter()
                    ->dateTime()
                    ->sortable()
                    ->toggleable(isToggledHiddenByDefault: true),
            ])
            ->filters([
                Tables\Filters\TrashedFilter::make(),
            ])
            ->actions([
                Tables\Actions\ViewAction::make(),
                Tables\Actions\EditAction::make(),
            ])
            ->bulkActions([
                Tables\Actions\BulkActionGroup::make([
                    Tables\Actions\DeleteBulkAction::make(),
                    Tables\Actions\ForceDeleteBulkAction::make(),
                    Tables\Actions\RestoreBulkAction::make(),
                ]),
            ])
            ->headerActions([
                ImportAction::make()
                    ->label('Import GR Masters')
                    ->color('warning')
                    ->importer(GrMasterImporter::class)
                    ->visible(function() {
                        return Filament::auth()->user()->can('view import gr master');
                    }),
                ExportAction::make()
                    ->label('Export GR Masters')
                    ->color('warning')
                    ->exporter(GrMasterExporter::class)
                    ->visible(function() {
                        return Filament::auth()->user()->can('view export gr master');
                    }),
            ]);
    }

    public static function getRelations(): array
    {
        return [
            //
        ];
    }

    public static function getPages(): array
    {
        return [
            'index' => Pages\ListGrMasters::route('/'),
            'create' => Pages\CreateGrMaster::route('/create'),
            'view' => Pages\ViewGrMaster::route('/{record}'),
            'edit' => Pages\EditGrMaster::route('/{record}/edit'),
        ];
    }

    public static function getEloquentQuery(): Builder
    {
        return parent::getEloquentQuery()
            ->withoutGlobalScopes([
                SoftDeletingScope::class,
            ]);
    }
}
